<?php
  /*
   * This source is made by flupke - flupke@wanadoo.fr
   *
   * This program is modifiable/redistributable under the terms of the GNU
   * General Public License.
   *
   * You should have recieved a copy of the GNU General Public License along
   * with this program; see the file COPYING. If not, write to the Free Software
   * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 0211-1307, USA.
   *
   */

if (!defined('__SQL_INCLUDED__')) {
  define('__SQL_INCLUDED__', 1);

//////////////////////////////////////////////////////////////////////////////
//include ('sqlSelectTable.php');

//////////////////////////////////////////////////////////////////////////////
define ('DIE_AT_CONNECTION_FAILURE', true);
define ('DEBUG_SQL_REQUESTS', 0);        // requests are echoed if set to true

define ('SQL_CONNECTION_ERROR', 'Impossible de se connecter au serveur SQL');

//////////////////////////////////////////////////////////////////////////////
// wrappers pour les fonctions SQL

function sql_connect($host='', $usr='', $pwd='', $db='') {
	global $SQL_HOST; 
	global $SQL_USR;
	global $SQL_PWD; 
	global $SQL_DB;

  // load default values from global variables for compatibility
  if ($host == '') $host = $SQL_HOST;
  if ($usr == '') $usr = $SQL_USR;
  if ($pwd == '') $pwd = $SQL_PWD;
  if ($db == '') $db = $SQL_DB;

/*  if (DEBUG_SQL_REQUESTS) {
    echo "sql connection to $host : ";
  }*/

	// Connexion au serveur
	if (!mysql_connect($host, $usr, $pwd)) {
/*    if (DEBUG_SQL_REQUESTS) {
      echo 'failed<br>';
    }*/
    
    if (DIE_AT_CONNECTION_FAILURE) {
      die(SQL_CONNECTION_ERROR);
    } else {
      return false;
    }
  }
	
  if ($db != '') {
  	if (!mysql_select_db($db)) {
/*      if (DEBUG_SQL_REQUESTS) {
        echo 'db selection failure<br>';
      }*/
    
      if (DIE_AT_CONNECTION_FAILURE) {
        die(SQL_CONNECTION_ERROR);
      } else {
        return false;
      }
    }
  }

/*  if (DEBUG_SQL_REQUESTS) {
    echo 'success<br>';
  }*/

  return true;
}

///////////////////////////////////////////////////////////////////////////////
function sql_disconnect() {
	// Deconnexion de la base de donnees
	mysql_close();
}

///////////////////////////////////////////////////////////////////////////////
// Quoted from php manual :
//    Only for SELECT statements mysql_query() returns a resource identifier or
//    FALSE if the query was not executed correctly. For other type of SQL
//    statements, mysql_query() returns TRUE on success and FALSE on error.
//    A non-FALSE return value means that the query was legal and could be
//    executed by the server. It does not indicate anything about the number
//    of rows affected or returned. It is perfectly possible for a query to
//    succeed but affect no rows or return no rows. 

function sql_query($query_str) {
  if (DEBUG_SQL_REQUESTS) {
    echo $query_str . "<br>\n";
  }
  return mysql_query($query_str);
}


///////////////////////////////////////////////////////////////////////////////
function sql_count($table, $cond) {
  $req = "SELECT COUNT(*) FROM $table $cond";
  if (DEBUG_SQL_REQUESTS) {
    echo $req;
  }
  $res = sql_query($req);
  $row = mysql_fetch_row($res);
  
  if ($row) {
    return $row[0];
  } else {
    return -1;
  }
}

///////////////////////////////////////////////////////////////////////////////
/* returns 'str' prepared for SQL operations

  Within a string, certain sequences have special meaning. Each of these sequences begins with a backslash (`\'), known as the escape character. MySQL recognises the following escape sequences: 

\0 An ASCII 0 (NUL) character. 
\' A single quote (`'') character. 
\" A double quote (`"') character. 
\b A backspace character. 
\n A newline character. 
\r A carriage return character. 
\t A tab character. 
\z ASCII(26) (Control-Z). This character can be encoded to allow you to work around the problem that ASCII(26) stands for END-OF-FILE on Windows. (ASCII(26) will cause problems if you try to use mysql database < filename.) 
\\ A backslash (`\') character. 
*/

function sql_prepare_str($str, $strip_slashes = false) {
  if ($strip_slashes == true)
    $str = stripslashes($str);
    
  $res = str_replace("\\", "\\\\", $str);
  $res = str_replace("\x00", "\\0", $res);
  $res = str_replace("'", "\\'", $res);
  $res = str_replace("\"", "\\\"", $res);
  $res = str_replace("\x08", "\\b", $res);
  $res = str_replace("\n", "\\n", $res);
  $res = str_replace("\r", "\\r", $res);
  $res = str_replace("\t", "\\t", $res);
  $res = str_replace("\x1a", "\\z", $res);
  return $res;
  
//  return mysql_escape_string($str);
}

///////////////////////////////////////////////////////////////////////////////
// shortcut that returns cols for tables that have a unique ID
function sql_get_cols($table, $id, $cols, $key = 'id', $conds = '') {
  $req = "SELECT $cols FROM $table WHERE $key = $id $conds";  
  $res = sql_query($req);
  return mysql_fetch_row($res);
}

///////////////////////////////////////////////////////////////////////////////
// just for consistency
function sql_fetch_row($res) {
  return mysql_fetch_row($res);
}

///////////////////////////////////////////////////////////////////////////////
function sql_fetch_array($res) {
  return mysql_fetch_array($res, MYSQL_ASSOC);
}

///////////////////////////////////////////////////////////////////////////////
function sql_num_rows($res) {
  return mysql_num_rows($res);
}

///////////////////////////////////////////////////////////////////////////////
// executes a file
function sql_exec_file($filename) {
  $success = true;  
  $cmd = "";
  
  $f = fopen($filename, "rt");  

  $i = 0;
  while (!feof ($f)) {
    $line = fgets($f, 1024 * 32);
    if (WIN32 != true)
      $line = str_replace("\r", '', $line);
    
    if (DEBUG_SQL_REQUESTS)
      echo "$i : $line<br>";

    if ((preg_match("/^[ ]*#.*$/", $line) != TRUE) && ($line != "\n")) {
      $cmd .= $line;
      if (DEBUG_SQL_REQUESTS)
        echo "<br><p>$cmd</p><br>";
    }
    
    if (preg_match("/^.*;[ ]*$/", $line) == TRUE) {
      if (DEBUG_SQL_REQUESTS)
        echo 'execution';
      $cmd = split(";", $cmd);
      $tmpStr = '';
      for ($i = 0 ; $i < count($cmd) - 1 ; $i++)
        $tmpStr .= $cmd[$i];
      if (sql_query($tmpStr) == FALSE) {
        echo "chbging!<br>";
        echo "requte SQL : $tmpStr<br>";
        echo mysql_error() . "<br>";
        $success = false;
      }
      $cmd = "";   
    }

    $i++;
  }
  fclose($f);

  return $success;
}


///////////////////////////////////////////////////////////////////////////////
/*
 * Classes for easy handling of sql objects
 */
///////////////////////////////////////////////////////////////////////////////

define ("SQL_DT_INT", 0);
define ("SQL_DT_VARCHAR", 1);
define ("SQL_DT_TEXT", 2);
define ("SQL_DT_BLOB", 3);

$SQLDTNames[SQL_DT_INT] = 'int';
$SQLDTNames[SQL_DT_VARCHAR] = 'varchar';
$SQLDTNames[SQL_DT_TEXT] = 'text';
$SQLDTNames[SQL_DT_BLOB] = 'blob';

class CSQLFieldDesc {
  var $name='';
  var $type=0;
  var $size=0;
  var $null=0;
  
  function CSQLFieldDesc($name, $type = SQL_DT_INT, $size = 32, $null = false) {
    $this->name = $name;
    $this->type = $type;
    $this->size = $size;
    $this->null = $null;
  }

  // returns a create string
  function getCreate() {
    global $SQLDTNames;

    // name
    $str = $this->name . ' ';
    
    // type
    $str .= $SQLDTNames[$this->type];
    if (($this->type != SQL_DT_BLOB) && 
        ($this->type != SQL_DT_TEXT)) {
      $str .= '(' . $this->size . ')';
    }    
    $str .= ' ';
    
    // null
    if ($this->null == true) {
      $str .= 'NULL';
    } else {
      $str .= 'NOT NULL';
    }

    return $str;
  }
}

///////////////////////////////////////////////////////////////////////////////
class CSQLDataObjDesc {
  var $table='';
  var $fields;

  // create table
  function create() {
    $hasKey = false;
    
    $req = 'CREATE TABLE ' . $this->table . '(';      
    $nbElts = count($this->fields);
    for ($i = 0 ; $i < $nbElts ; $i++) {
      $req .= $this->fields[$i]->getCreate();
      
      // special case, ids are automatically made auto_increment
      if (($i == 0) &&
          ($this->fields[$i]->name == 'id') && 
          ($this->fields[$i]->type == SQL_DT_INT) &&
          ($this->fields[$i]->size == 32) &&
          ($this->fields[$i]->null == false)) {
        $req .= ' auto_increment';
        $hasKey = true;
      }
      
      if ($i != $nbElts - 1) {
        $req .= ', ';
      }
    }

    if ($hasKey == true) {
      $req .= ', PRIMARY KEY (id)';
    }

    $req .= ')';
    
    return sql_query($req);
  }

  // drop table
  function drop() {
    $req = 'DROP TABLE ' . $this->table;
    return sql_query($req);
  }
}

///////////////////////////////////////////////////////////////////////////////
class CSQLObject {
  var $dd;
  var $fields;      // associative array containing data ; keys are taken from
                    // fields name in dd

  function CSQLObject($dd) {
    $this->dd = $dd;
  }

  // loads an array
  function load($row) {
    if (!$this->dd) {
      return false;
    }

    // do nothing if field count is not the same as dd's
    $nbElts = count($row);
    if ($nbElts != count($this->dd->fields))
      return false;
    
    // make associative array
    $this->fields = array();
    for ($i = 0 ; $i < $nbElts ; $i++) {
      $this->fields[$this->dd->fields[$i]->name] = $row[$i];
    }

    return true;      
  }
  
  // load a single object from db with condition
  function select($cond) {
    if (!$this->dd) {
      return false;
    }
    
    // make SELECT query
    $req = 'SELECT ';
    $nbElts = count($this->dd->fields);    
    for ($i = 0 ; $i < $nbElts ; $i++) {
      $req .= $this->dd->fields[$i]->name;
      if ($i != $nbElts - 1) {
        $req .= ', ';
      }
    }
    $req .= ' FROM ' . $this->dd->table . " WHERE $cond";
    
    // load data
    if (($res = sql_query($req)) == false)
      return false;
    $row = sql_fetch_row($res);

    return $this->load($row);
  }

  // insert object in db
  function insert() {
    if (!$this->dd) {
      return false;
    }
    
    $nbElts = count($this->dd->fields);
    $req = 'INSERT INTO ' . $this->dd->table . '(';
    for ($i = 0 ; $i < $nbElts ; $i++) {
      $req .= $this->dd->fields[$i]->name;
      if ($i != $nbElts - 1) {
        $req .= ', ';
      }
    }
    
    $req .= ') VALUES (';
    for ($i = 0 ; $i < $nbElts ; $i++) {
      $req .= '\'' . $this->fields[$i] . '\'';
      if ($i != $nbElts - 1) {
        $req .= ', ';
      }
    }
    $req .= ')';

    return sql_query($req);
  }
}

///////////////////////////////////////////////////////////////////////////////
// simple class interfacing a php associative array with SQL row(s)
//
// note: SQL conditions for update and saveUnique functions must not include
//       WHERE keyword

class CSQLRow {
  /////////////////////////////////////////////////////////////////////////////
  var $data;                                  // associative array storing data

  /////////////////////////////////////////////////////////////////////////////
  function CSQLRow() { }  

  /////////////////////////////////////////////////////////////////////////////
  function loadArray($row) {
    $this->data = $row;
  }
  
  /////////////////////////////////////////////////////////////////////////////
  function load($table, $cond = '') {
    $req = "SELECT * FROM $table $cond";
    $res = sql_query($req);
    $this->loadArray(sql_fetch_array($res));
  }

  /////////////////////////////////////////////////////////////////////////////
  // classic insert function
  function insert($table) {
    if (count($this->data) < 1)
      return false;
    
    $req = "INSERT INTO $table (";
    
    $i = 0;
    foreach ($this->data as $field => $data) {
      if ($i != 0) $req .= ", ";
      $req .= $field;
      $i++;
    }
    
    $req .= ") VALUES (";
    
    $i = 0;
    foreach ($this->data as $data) {
      if ($i != 0) $req .= ", ";
      $data = sql_prepare_str($data);
      $req .= "'$data'";      
      $i++;
    }

    $req .= ')';

    return sql_query($req);
  }

  /////////////////////////////////////////////////////////////////////////////
  // classic update function
  function update($table, $cond) {
    if (count($this->data) < 1)
      return false;
    if (trim($cond) == '')
      return false;
    
    $req = "UPDATE $table SET ";
    
    $i = 0;
    foreach ($this->data as $field => $data) {
      if ($i != 0) $req .= ", ";
      $data = sql_prepare_str($data);
      $req .= "$field = '$data'";
      $i++;
    }

    $req .= " WHERE $cond";
    
    return sql_query($req);
  }
  
  /////////////////////////////////////////////////////////////////////////////
  // this one inserts the data if no row mathes the given condition, or update
  // the rows matched by the condition else
  function saveUnique($table, $cond) {
    if (sql_count($table, "WHERE $cond")) {
      return $this->update($table, $cond);
    } else {
      return $this->insert($table);
    }      
  }
  
  /////////////////////////////////////////////////////////////////////////////
  // inserts the row only if no rows match the condition
  function add($table, $cond) {
    if (sql_count($table, "WHERE $cond") == 0) {
      return $this->insert($table);
    }

    return false;
  }
  
  /////////////////////////////////////////////////////////////////////////////
  // return the row formated in XML format
  function XMLRender() {
    $res = "<row>";
    foreach ($this->data as $field => $data) {
      $res .= "<col name=\"$field\">$data</col>";
    }
    $res .= "</row>";

    return $res;
  }
};

///////////////////////////////////////////////////////////////////////////////
// class to represent a SQL table (only a collection of CSQLRows)
class CSQLTable {
  /////////////////////////////////////////////////////////////////////////////
  var $name;  
  var $rows;

  /////////////////////////////////////////////////////////////////////////////
  function CSQLTable($name) {
    $this->name = $name;
  }
  
  /////////////////////////////////////////////////////////////////////////////
  function select($cond = '') {
    $req = "SELECT * FROM $this->name $cond";
    $res = sql_query($req);
    $this->rows = array();
    $i = 0;
    while ($row = sql_fetch_array($res)) {
      $this->rows[$i] = new CSQLRow();
      $this->rows[$i]->loadArray($row); 
      $i++;
    }
  }

  /////////////////////////////////////////////////////////////////////////////
  function delete($cond = '') {
    $req = "DELETE FROM $this->name $cond";
    return sql_query($req);
  }
  
  /////////////////////////////////////////////////////////////////////////////
  function insert($fixed = array()) {
    foreach ($this->rows as $row) {
      // set fixed values
      foreach ($fixed as $k => $v)
        $row->data[$k] = $v;
      
      $row->insert($this->name);
    }
  }
  
  /////////////////////////////////////////////////////////////////////////////
  function add($key, $fixed = array()) {
    foreach ($this->rows as $row) {
      // set fixed values
      foreach ($fixed as $k => $v)
        $row->data[$k] = $v;
      
      $row->add($this->name, "$key = '{$row->data[$key]}'");
    }
  }
  
  /////////////////////////////////////////////////////////////////////////////
  // return the table formated in XML format
  function XMLRender() {
    $res = "<table name=\"$this->name\">";
    foreach ($this->rows as $row) $res .= $row->XMLRender();
    $res .= "</table>";

    return $res;
  }
}

}

?>
